| The Gaudi Framework v28r2p1 (f1a77ff4)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Private Types | Private Member Functions | Private Attributes | Friends | List of all members
Gaudi::Functional::details::vector_of_const_< Container >::iterator Class Reference

`#include <GaudiAlg/FunctionalDetails.h>`

## Public Member Functions
ret_t | operator* () const
iterator & | operator++ ()
iterator & | operator-- ()
bool | is_null () const
| operator bool () const

## Private Types
using | ret_t = std::conditional_t< is_optional, ptr_t, ref_t >

## Private Member Functions
| iterator (typename ContainerVector::const_iterator iter)

## Private Attributes
ContainerVector::const_iterator | m_i

## Friends
class | vector_of_const_
bool | operator!= (const iterator &lhs, const iterator &rhs)

## Detailed Description

### template<typename Container>
class Gaudi::Functional::details::vector_of_const_< Container >::iterator

Definition at line 181 of file FunctionalDetails.h.

## Member Typedef Documentation

template<typename Container >

using Gaudi::Functional::details::vector_of_const_< Container >::iterator::ret_t = std::conditional_t<is_optional,ptr_t,ref_t>
| private

Definition at line 185 of file FunctionalDetails.h.

## Constructor & Destructor Documentation

template<typename Container >

Gaudi::Functional::details::vector_of_const_< Container >::iterator::iterator | ( | typename ContainerVector::const_iterator | iter | ) |
| inline private

Definition at line 184 of file FunctionalDetails.h.

184 : m_i(iter) {}
Gaudi::Functional::details::vector_of_const_::iterator::m_i
ContainerVector::const_iterator m_i
Definition: FunctionalDetails.h:182

## Member Function Documentation

template<typename Container >

bool Gaudi::Functional::details::vector_of_const_< Container >::iterator::is_null | ( |  | ) | const
| inline

Definition at line 191 of file FunctionalDetails.h.

191 { return !*m_i; }
Gaudi::Functional::details::vector_of_const_::iterator::m_i
ContainerVector::const_iterator m_i
Definition: FunctionalDetails.h:182
template<typename Container >

Gaudi::Functional::details::vector_of_const_< Container >::iterator::operator bool | ( |  | ) | const
| inline explicit

Definition at line 192 of file FunctionalDetails.h.

192 { return !is_null(); }
Gaudi::Functional::details::vector_of_const_::iterator::is_null
bool is_null() const
Definition: FunctionalDetails.h:191
template<typename Container >

ret_t Gaudi::Functional::details::vector_of_const_< Container >::iterator::operator* | ( |  | ) | const
| inline

Definition at line 188 of file FunctionalDetails.h.

188 { return details2::deref_if(*m_i, std::integral_constant<bool,!is_optional>{}); }
Gaudi::Functional::details::vector_of_const_::iterator::m_i
ContainerVector::const_iterator m_i
Definition: FunctionalDetails.h:182
Gaudi::Functional::details::details2::deref_if
T * deref_if(T *const t, std::false_type)
Definition: FunctionalDetails.h:166
std::integral_constant
template<typename Container >

iterator& Gaudi::Functional::details::vector_of_const_< Container >::iterator::operator++ | ( |  | ) |
| inline

Definition at line 189 of file FunctionalDetails.h.

189 { ++m_i; return *this; }
Gaudi::Functional::details::vector_of_const_::iterator::m_i
ContainerVector::const_iterator m_i
Definition: FunctionalDetails.h:182
template<typename Container >

iterator& Gaudi::Functional::details::vector_of_const_< Container >::iterator::operator-- | ( |  | ) |
| inline

Definition at line 190 of file FunctionalDetails.h.

190 { --m_i; return *this; }
Gaudi::Functional::details::vector_of_const_::iterator::m_i
ContainerVector::const_iterator m_i
Definition: FunctionalDetails.h:182

## Friends And Related Function Documentation

template<typename Container >

bool operator!= | ( | const iterator & | lhs,
|  | const iterator & | rhs
| ) |  |
| friend

Definition at line 187 of file FunctionalDetails.h.

187 { return lhs.m_i != rhs.m_i; }
template<typename Container >

friend class vector_of_const_
| friend

Definition at line 183 of file FunctionalDetails.h.

## Member Data Documentation

template<typename Container >

ContainerVector::const_iterator Gaudi::Functional::details::vector_of_const_< Container >::iterator::m_i
| private

Definition at line 182 of file FunctionalDetails.h.

The documentation for this class was generated from the following file:

- GaudiAlg/GaudiAlg/FunctionalDetails.h